#include "ECString.h"
#include "Gov3.h"
#include "EmPronoun.h"
#include "Tree.h"
#include "math.h"
static pthread_mutex_t govlock = PTHREAD_MUTEX_INITIALIZER;

void
decodeAnte(stIndex encoded,stIndex& antew,int& pos)
{
  pos=encoded%3;
  antew=encoded/3;
}

stIndex
encodeAnte(stIndex ante, int pos)
{
  stIndex ans=pos+(3*ante);
  return ans;
}

stIndex
encodeAnte2(stIndex ante,int posno)
{
  int pos;
  if(ante==0)pos=0;
  else{
    pos=2;
    string posstr=Tree::gst->toString(posno);
    if(posstr=="NNP"||posstr=="NNPS")pos=1;
    else if(posstr=="NN"||posstr=="NNS")pos=0;
  }
  return (ante*3)+pos;
}
  
stIndex
Gov::
getStem(stIndex wrd)
{
  //return wrd;
  map<stIndex,stIndex>::iterator stmI=stems.find(wrd);
  if(stmI==stems.end())return wrd;
  else return (stmI->second);
}
void
Gov::
readStems()
{
    ifstream govws("govWs.txt");
    ifstream govstm("govWs.stm");
    for(;;){
      string wrd,stm;
      stIndex wrdsti,stmsti;
      govws>>wrd;
      if(!govws)break;
      wrdsti=Tree::gst->toIndex(wrd);
      govstm>>stm;
      stmsti=Tree::gst->toIndex(stm);
      stems[wrdsti]=stmsti;
    }
}
    

string
sym(Tree* t)
{
  return Tree::gst->toString(t->label);
}

stIndex 
encodeSyntaxNo(stIndex gov,int syn)
{
  stIndex ans=gov*LASTSYN;
  ans+=syn;
  return ans;
}

void 
decodeSyntaxNo(stIndex stgov,stIndex& gov, int& i)
{
  gov=stgov/LASTSYN;
  i=stgov%LASTSYN;
}

void 
Gov::
addGovRel(stIndex npw,stIndex govw,int synno,int posno)
{
  stIndex npc=EmPronoun::cannonize(npw);
  stIndex np=getStem(npc);
  stIndex npenc=encodeAnte2(np,posno);
  stIndex gov=getStem(govw);
  pthread_mutex_lock(&govlock);
  gov=encodeSyntaxNo(gov,synno);
  StMapC& stmc =ststMap[npenc];
  stmc.c+=10;;
  stmc.cntc(gov)+=10;
  pthread_mutex_unlock(&govlock);
}

void
Gov::
writeGovs(ostream& os)
{
  StstMap::iterator ststI=ststMap.begin();
  for(;ststI!=ststMap.end();ststI++){
    stIndex antei=ststI->first;
    string antew;
    stIndex antesti;
    int pos;
    if(antei>0){
      decodeAnte(antei,antesti,pos);
      antew=Tree::gst->toString(antesti);
    }
    else{
      antew="EXPL";
      pos=0;
    }
    StcMap::iterator stcI=ststI->second.stcMap.begin();
    int numGoves=0;
    for(;stcI!= ststI->second.stcMap.end();stcI++){
      int num=CNTfITR(stcI);
      if(num>=10)numGoves++;
    }
    if(numGoves>0){
      os <<antew<<" "<<pos;
      os<<" "<<(int)(ststI->second.c/10);
      os<< " "<< numGoves<<endl;
      for(stcI=ststI->second.stcMap.begin();
	  stcI!= ststI->second.stcMap.end();stcI++){
	stIndex encoded=stcI->first;
	stIndex gov;
	int synno;
	int num=CNTfITR(stcI);
	if(num<10)continue;
	decodeSyntaxNo(encoded,gov,synno);
	assert(gov>0);
	char buf[1028];
	sprintf(buf,"\t%s\t%i\t%i\n",Tree::gst->toString(gov).c_str(),synno,
		num);
	os<<buf;
      }
    }
  }
}

void
Gov::
postComp(istream& is)
{
 for(;;){
    string tmp1,tmp2;
    stIndex t1,t2,tenc;
    int i,c,n,j,s,pos;
    is>>tmp1;
    if(!is)break;
    is>>pos;
    is>>c;
    is>>n;
    if(tmp1=="EXPL")tenc=0;
    else{
      t1=Tree::gst->toIndex(tmp1);
      tenc=encodeAnte(t1,pos);
    }
    StMapC& stmc=ststMap[tenc];
    /* also associate info with class of antecedent */
    int clss=stmc.clss;
    /*after finding class, stem ante*/
    StMapC& stmc2=ststMap[tenc];
    //if(clss<0)cerr<<"NOCLASS"<<endl;
    StMapC& stcm=ststcMap[clss];
    for(i=0;i<n;i++){
      is>>tmp2;
      t2=Tree::gst->toIndex(tmp2);
      is>>s;
      if(s==19) s=POS;
      stIndex synGov=encodeSyntaxNo(t2,s);
      is>>j;
      stmc2.cp+=j;
      stmc2.probcc(synGov)+=j;
      stcm.cp+=j;
      stcm.probcc(synGov)+=j;
    }
  }
  ds[0]=.9;
  ds[1]=.8;
  ndotdot=0;
  StstMap::iterator ststI;
  for(ststI=ststcMap.begin();ststI!=ststcMap.end();ststI++){
    StMapC& stmc=ststI->second;
    stmc.oneMlam=ds[1]*(float)stmc.stcMap.size()/(float)(stmc.cp/10.0);
    StcMap::iterator stcmI=stmc.stcMap.begin();
    for(;stcmI!=stmc.stcMap.end();stcmI++){
      stIndex sti=stcmI->first;
      StcMap::iterator n1pI=n1pMap.find(sti);
      if(n1pI==n1pMap.end()){
	ndotdot++;
	CNTfANS(n1pMap[sti])=1;
      }
      else CNTfITR(n1pI)++;
    }
  }
  ststI=ststMap.begin();
  for(;ststI!=ststMap.end();ststI++){
    StMapC& stmc=ststI->second;
    stmc.oneMlam=(ds[0]*stmc.stcMap.size())/((float)stmc.cp/10.0);
  }
}

float
Gov::
rawProbs(stIndex ante, stIndex gov, int synno,int pos,float prb)
{
  ante=EmPronoun::cannonize(ante);
  stIndex antet=ante;
  ante=getStem(ante);
  stIndex anteo=ante;
  if(ante>0)ante=encodeAnte2(ante,pos);
  else pos=0;
  gov=getStem(gov);
  if(synno==19)synno=POS;
  gov=encodeSyntaxNo(gov,synno);
  float ans=0;
  StMapC& stmc=ststMap[ante];
  if(prb>=0){
    int nprob=(int)(prb*10);
    if(nprob>0){
      stmc.cntc(gov)+=nprob;
      stmc.c+=nprob;
    }
    return ans;
  }
  if(stmc.cp==0){
    stmc.probcc(gov)=1;
    stmc.cp=100;
    ans=.01;
  }
  else{
    StcMap::iterator stcmI=stmc.stcMap.find(gov);
    if(stcmI==stmc.stcMap.end()){
      ans=.01;
      stmc.cp=100;
      stmc.probcc(gov)=1;;
    }
    else ans=(float)PRBfITR(stcmI)/(float)stmc.cp;
  }
  return ans;
}

float
Gov::
pGov(stIndex antew,stIndex gov1w,int synno,int pos)
{
  int show=0;
  stIndex ante1=EmPronoun::cannonize(antew);
  stIndex antes=getStem(ante1);
  stIndex gov1s=getStem(gov1w);
  if(synno==19)synno=POS;
  stIndex gov=encodeSyntaxNo(gov1s,synno);

  string antestring="EXPL";
  if(antes>0){
    antestring=Tree::gst->toString(antes);
    antes=encodeAnte2(antes,pos);
  }
  if(show)cerr<<"p("<<Tree::gst->toString(gov1s)<<"|"<<antestring<<") ";
  float back=10e-6;
  /* at this point gov is encoded stemmed gov + synno */
  StcMap::iterator stcmI=n1pMap.find(gov);
  if(stcmI==n1pMap.end()){
    if(show)cerr<<back<<" gov oov\n";
    return back; //if gov is oov return 10e-6;
  }
  back=(float)CNTfITR(stcmI)/(float)ndotdot;
  //StstMap::iterator ststI=ststMap.find(ante1); //before stem get class; ???
  StstMap::iterator ststI=ststMap.find(antes); //use stem for class;
  if(ststI==ststMap.end()){
    if(show)cerr<<back<<" ante oov\n";
    return back; //if ante is oov return N1+(g.)/N(..);
  }
  int clss=ststI->second.clss;
  ststI=ststMap.find(antes);  //now use stem;
  assert(ststI!=ststMap.end());
  StMapC& stmc=ststI->second;
  float ansc=0;
  StMapC& stmcc=ststcMap[clss];
  if(stmcc.cp==0)
    cerr<<"Class with zero size "<< clss<<endl;
  int stcnumerator=stmcc.probcc(gov);
  if(stcnumerator>0)
    ansc=((float) (stcnumerator/10.0)-ds[1])/((float)stmcc.cp/10.0);
  if(stmc.cp==0){
    /* if word has a class, but did not appear in training data */
    cerr<<"UK ante "<<ansc<<endl;
    if(!stmc.stcMap.empty())
      cerr<<"SZ = "<<stmc.stcMap.size()<<endl;
    if(ansc==0)ansc=1.0e-7;
    return ansc;
  }
  float oback=back;
  back*=stmcc.oneMlam;
  back+=ansc;
  assert(!isnan(back));
  //if(show) cerr<<"CL "<<clss<<" "<<back<<"\n";
  //return back; //???:
  float bk1=stmc.oneMlam;
  assert(!isnan(bk1));
  back*=bk1;
  int stcNum2=stmc.probc(gov);
  if(stcNum2<0){
    if(show)
    cerr
      <<" |g a|=0 "<< clss<<" "
      <<ansc<<" "
      <<oback<<" "
      <<back
      <<"\n";

    return back;
  }
  if(stmc.cp==0)    cerr<<"Zero denom for main prob\n";
  assert(stmc.stcMap.size()>0);
  float ans=((((float)stcNum2/10.0) -ds[0])/((float)stmc.cp/10.0))+back;
  if(show)
  cerr
    <<" compl "<<clss<<" "
    <<ansc<<" "
    << ans
    <<endl;
  //cerr<<"\t"<<stcNum2<<" "<<stmc.cp<<" "<<back<<" "<<stmcc.oneMlam
  //<<" "<<oback<<" "<<stmc.oneMlam<<endl;
  return ans;
}


void
Gov::
wclassRead(istream& is)
{
  int cnum=0;
  for(;;cnum++){
    int numws;
    is>>numws;
    if(!is)break;
    for(int i=0;i<numws;i++){
      string wd;
      is>>wd;
      stIndex wdsti=0;
      int wtyp;
      is>>wtyp;
      if(wd!="EXPL")wdsti = Tree::gst->toIndex(wd);
      stIndex enc=encodeAnte(wdsti,wtyp);
      ststMap[enc].clss=cnum;
    }
  }
}
