
#ifndef STBL_H
#define STBL_H

#include "assert.h"
#include <map>
#include <vector>
#include "ECString.h"
#include <iostream>

typedef unsigned int stIndex;
typedef unsigned int usi;
typedef map<string,usi> symMap;
typedef symMap::iterator symMapI;


class SymbolTable
{
 public:
  SymbolTable():fword(0),lword(0){sarray.push_back("");}
  string   toString(stIndex i) {
    if(!(i>0&&i<sarray.size())){
      cerr<<"Bad index "<<i<<endl;
      assert(0);
    }
    else return sarray[i];
  }
  stIndex toIndex(string s){
    symMapI smi=smap.find(s);
    if(smi== smap.end()){
      int nn=sarray.size();
      sarray.push_back(s);
      smap[s]=nn;
      return nn;
    }
    else return smi->second;
  }
  stIndex isThere(string s){
    symMapI smi=smap.find(s);
    if(smi== smap.end())return 0;
    else return smi->second;
  }
  stIndex toindex(string s){
    symMapI smi=smap.find(s);
    if(smi== smap.end()) return 0;
    else return smi->second;
  }
  bool okWord(stIndex sti){return(sti>=fword&&sti<=lword);}
  stIndex fword;
  stIndex lword;
  symMap smap;
  vector<string> sarray;
};

#endif
