
#ifndef TREE_H
#define TREE_H

#include "ECString.h"
#include <fstream>
#include <sys/resource.h>
#include <iostream>
#include <stdlib.h>
#include "SymbolTable.h"

#define NEWSTORY 9999999
#define CATSEP		"-=|#~"		/* separates categories */
#define MAXLABELLEN 512
class Tree
{
 public:
  Tree(stIndex i) : numprev(0),refnum(0),reftype(0),label(i),subtrees(NULL),sibling(NULL),pprob(0),parent(NULL)
    { int j; for(j=0;j<10;j++)vals[j]=0; }

  Tree(istream& is,SymbolTable*st);    
  Tree(Tree& other);
  ~Tree(){
    if(subtrees) delete subtrees;
    if(sibling) delete sibling;
  }
  static void readStory(istream& is);
  void writeYield(ostream& os);
  Tree* checkHTree();
  short       vals[10];
  short       numprev;
  short       refnum;
  short       reftype;
  stIndex     label;
  float       pprob;
  Tree  *subtrees;
  Tree  *sibling;
  Tree  *parent;
  Tree  *htree;
  string word;
  void  write(ostream& os, SymbolTable* st);
  void  write(ostream& os){ write(os,gst); os<<endl; }
  static Tree* make(istream& is,SymbolTable* st);
  static int singleLineReader; //default=1, set to 0 to read prettyprinted trees.
  Tree* hTreeFromTree();
  static Tree* readB(istream& is,int& cp,string& buf,SymbolTable* st);
  int   hpos();
  static bool writeStrip;
  static SymbolTable* gst;
  int  wPos();
  int wPos(Tree* ht,int& pos);
  static int inputNo;
  static int storyDone;
  static vector<Tree*> story;
  static int toLower;
 private:
  static void* readStoryLoop(void* arg);
  void   writeVals(ostream& os);
};
 
void addParent(Tree* tr,Tree* par);
 

#endif
