#include "ECString.h"
#include "ECArgs.h"
#include "Tree.h"
#include "headFinder.h"
#include "ntInfo.h"
#include "EmPronoun.h"
#include "files.h"
#include <set>
#include <string.h>

//int numIters=11; //???
int numIters=16; //???
SymbolTable* gst;
int storyLimit=15000;
int storyBegin=0;
ifstream* treeifsp;
ostream* sumosp=NULL;
EmPronoun* empp=NULL;
#define MAXNUMTHREADS 4
int numThreads =1;
int storyNo=0;
int storyLoopCnt=0;
int version=1;
files *fls = NULL;
static pthread_mutex_t readlock = PTHREAD_MUTEX_INITIALIZER;
static pthread_mutex_t writelock = PTHREAD_MUTEX_INITIALIZER;

static void*
sumLoop(void* arg)
{
  for(;nextFile(fls);){
    for(;;){
      StoryInfo stI;
      vector<string> bufs;
      pthread_mutex_lock(&readlock);
      int locStoryNo=storyNo++;
      /* loop over sentences */
      for(;;){
	string buf;
	getline(fls->from,buf);
	if(!fls->from)break;
	if(buf.empty())break;
	bufs.push_back(buf);
      }
      pthread_mutex_unlock(&readlock);
      if(!fls->from&&bufs.empty())break;
      stI.storyNo=locStoryNo;
      int stno=0;
      vector<string>::iterator vsI =bufs.begin();
      Trees trees;
      Tree* ti;
      for(;vsI!=bufs.end();vsI++){
	stI.sentNo=stno++;
	int dummyI=0;
	ifstream dummyS("foo");
	ti=Tree::readB(dummyS,dummyI,*vsI,Tree::gst);
	addParent(ti,NULL);
	empp->summarize(ti,stI);
	trees.push_back(ti);
	stI.wordNo=0;
      }
      for(int i=0;i<stI.sums.size();i++)empp->proc(i,stI);
    
      pthread_mutex_lock(&writelock);
      Trees::iterator tI=trees.begin();
      for(;tI!=trees.end();tI++){
	Tree* tmp=(*tI);
	tmp->write(cout);
      }
      cout<<"\n";
      pthread_mutex_unlock(&writelock);
      for(tI=trees.begin();tI!=trees.end();tI++)delete(*tI);
    }
  }
  return 0;
}

int
main(int argc, char *argv[])
{
  cerr.precision(3);
  cout.precision(4);
  struct rlimit         core_limits;
  core_limits.rlim_cur = 0;
  core_limits.rlim_max = 0;
  setrlimit( RLIMIT_CORE, &core_limits );

  pthread_t thread[MAXNUMTHREADS];
  ECArgs args(argc,argv);
  char dat[256];
  strcpy(dat,args.arg(0).c_str());
  Tree::singleLineReader=1;
  SymbolTable st;
  Tree::gst=gst=&st;
  ifstream ifs("ntInfo.txt");
  readNtInfo(ifs,&st);
  st.fword=st.sarray.size()+1;
  readHeadInfo("",&st);
  EmPronoun emp;
  empp=&emp;
  ifstream ifsg("gov.all");
  emp.action=TEST;
  emp.readProbs();
  emp.stage=GOV;
  numThreads=1;
  if(ifsg)emp.gov.postComp(ifsg);
  treeifsp = new ifstream("dev.par");
  fls=initFiles(dat,".txt","","",199,ALL,1);
  int i;
  for(i = 0 ; i < numThreads  ; i++){
    pthread_create(&thread[i],0,sumLoop, 0);
  }
  for(i=0; i<numThreads; i++){
    pthread_join(thread[i],0);
  }
  /*
  cerr<<emp.results[0]<<" "<<emp.results[1]<<" "
      <<(float)emp.results[0]/(float)emp.results[1]<<endl;
  */
  exit(0);
}
